"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = init;
exports.fromFile = fromFile;

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _spec = require("./spec");

var _spec2 = _interopRequireDefault(_spec);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = _bluebird2.default.promisifyAll(require("fs"));

var noop = function noop(val) {
  return val;
};

function init(obj) {
  return Object.keys(_spec2.default).reduce(function (final, key) {
    var val = obj[key] || _spec2.default[key].defaultValue;
    if (val) {
      final[key] = (_spec2.default[key].transform || noop)(val);
    }
    return final;
  }, {});
}

function fromFile(root) {
  var configFile, config;
  return regeneratorRuntime.async(function fromFile$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          configFile = _path2.default.join(root, "catalyst.json");
          _context.next = 3;
          return regeneratorRuntime.awrap(fs.readFileAsync(configFile, { encoding: "utf8" }));

        case 3:
          config = _context.sent;
          return _context.abrupt("return", init(JSON.parse(config)));

        case 5:
        case "end":
          return _context.stop();
      }
    }
  }, null, this);
}