"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mergeWithProps = mergeWithProps;
exports.mergeWithObj = mergeWithObj;
function propsFromObject(obj, base) {
  return Object.keys(obj).reduce(function (props, key) {
    props[key] = Object.assign({}, { value: obj[key] }, base);
    return props;
  }, {});
}

function mergeWithProps(currProps, newProps) {
  var overwrite = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];

  if (overwrite === false) {
    return Object.assign({}, newProps, currProps);
  }
  return Object.assign({}, currProps, newProps);
}

function mergeWithObj(currProps, newObj) {
  var overwrite = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];

  return mergeWithProps(currProps, propsFromObject(newObj, { enumerable: true }), overwrite);
}