"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.md = md;
exports.yaml = yaml;

var _jsYaml = require("js-yaml");

function md(str) {
  var obj = {};
  var front = str.match(/---([\s\S]*?)---/);
  if (front) {
    Object.assign(obj, (0, _jsYaml.safeLoad)(front[1]));
    obj.body = str.replace(front[0], "").trim();
  } else {
    obj.body = str.trim();
  }
  return obj;
}

function yaml(str) {
  return (0, _jsYaml.safeLoad)(str);
}

exports.default = {
  md: md,
  yaml: yaml
};