"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {

  return function catalyze(node, parent, root) {

    var self = Object.create(Object.prototype, node.data);
    if (parent) {
      if (parent.inheritance) {
        self = Object.create(parent.inheritance, node.data);
      }
      Object.defineProperty(self, "parent", { value: parent });
    }

    if (!root) {
      root = self;
    }
    Object.defineProperty(self, "root", { value: root });

    if (node.inheritance) {
      var inheritance = Object.create(Object.prototype, node.inheritance);
      Object.defineProperty(self, "inheritance", { value: inheritance });
    }

    if (node.children) {
      var children = node.children.reduce(function (all, obj) {
        all[obj.data.slug.value] = catalyze(obj, self, root);
        return all;
      }, {});
      Object.defineProperty(self, "children", { value: Object.freeze(children) });
    }

    return self;
  };
};