"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {

  return (0, _mapRecurse2.default)(function (node) {
    if (node.data) {
      refInProps(node.data);
    }
    if (node.inheritance) {
      refInProps(node.inheritance);
    }
    return node;
  });
};

var _lodash = require("lodash.get");

var _lodash2 = _interopRequireDefault(_lodash);

var _mapRecurse = require("../mapRecurse");

var _mapRecurse2 = _interopRequireDefault(_mapRecurse);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// */parent/child/grandchild.property.property
var refRE = /^\*((?:\/[\w-]+)+(?:\.[\w-]+)*)$/g;

function getRefClosure(ref) {
  var path = ref.replace(/\*\//, "").replace(/\//g, ".children.");
  return function getRef() {
    return (0, _lodash2.default)(this.root.children, path);
  };
}

function refInProps(props) {
  Object.keys(props).forEach(function (key) {
    var value = props[key].value;
    if (refRE.test(value)) {
      props[key].get = getRefClosure(value);
      delete props[key].value;
    }
  });
}