"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {

  return (0, _mapRecurse2.default)(function (node) {

    if (!node.children) {
      return node;
    }

    (0, _sortChildren2.default)(node);

    var dirs = node.children.filter(function (obj) {
      return obj.isDirectory;
    });
    var files = node.children.filter(function (obj) {
      return obj.isFile;
    });
    var children = [];

    files.forEach(function (obj) {
      var match = dirs.find(function (d) {
        return d.path.name === obj.path.name;
      });
      if (match) {
        match.data = (0, _mergeProps.mergeWithProps)(match.data, obj.data);
      } else {
        children.push(obj);
      }
    });

    node.children = children.concat(dirs);
    return node;
  });
};

var _mapRecurse = require("../mapRecurse");

var _mapRecurse2 = _interopRequireDefault(_mapRecurse);

var _mergeProps = require("../mergeProps");

var _sortChildren = require("../sortChildren");

var _sortChildren2 = _interopRequireDefault(_sortChildren);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }