"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require("bluebird");

var _bluebird2 = _interopRequireDefault(_bluebird);

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = _bluebird2.default.promisifyAll(require("fs"));
var mkdirp = _bluebird2.default.promisify(require("mkdirp"));

function mkdirpAll(paths) {
  return _bluebird2.default.all(paths.map(function (p) {
    return mkdirp((0, _path.parse)(p).dir, undefined);
  }));
}

exports.default = function write(dist, files) {
  return regeneratorRuntime.async(function write$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          files.forEach(function (f) {
            f.path = (0, _path.join)(dist, f.path);
          });
          _context.next = 3;
          return regeneratorRuntime.awrap(mkdirpAll(files.map(function (f) {
            return f.path;
          })));

        case 3:
          return _context.abrupt("return", _bluebird2.default.all(files.map(function (f) {
            return fs.writeFileAsync(f.path, f.data);
          })));

        case 4:
        case "end":
          return _context.stop();
      }
    }
  }, null, this);
};